<?


		//	classes


			//	iTunesCleanUp: class;
			//	iTunesCleanUp: the agent that searches (recursively) all directories on the (local or server) system

				class iTunesCleanUp {


				//	properties


					//	simulate: boolean;
					//	simulate: false, if no file operations should take place

						var  $simulate;


				//	methods


					//	iTunesCleanUp: procedure;
					//	iTunesCleanUp: create a new iTunesCleanUp (constructor)

						function iTunesCleanUp($simulate = true) {
							$this->simulate = $simulate;
						}


					//	run: procedure(path);
					//	run: scan the current folder

						function run($folder = '/Volumes/JUKEBOX/iTunes/iTunes Music/') {
							chdir($folder);
							//	echo($folder . "\n");
							$handle = opendir($folder);
							if (! $handle)
								return (0);
							while (($file = readdir($handle)) != false) {
								if (! strcmp('.', $file))
									continue;
								if (! strcmp('..', $file))
									continue;
								if (is_dir($file)) {
									$this->folder_event($file);
									$this->run($folder . $file . '/');
									chdir($folder);
								} else {
									//	echo("- {$file}\n");
									if ($this->is_match($file))
										$this->file_event($folder, $file);
								}
							}
							closedir($handle);
						}


					//	is_match: -> bool;
					//	is_match: test, if file matches criterion (full path/filename is in $file)

						function is_match($file) {
							return (eregi('\.(mp3|aif|aiff|m4a|mov|mpeg)$', $file));
						}


					//	file_event: procedure;
					//	file_event: the hook for a file (full path/filename is in $file)

						function file_event($folder, $file) {
							$f1 = $file;
							for ($i = 1; $i <= 10; $i++) {
								$f0 = ereg_replace('^(.+) ' . $i . '\.(mp3|aif|aiff|m4a|mov|mpeg)$', '\1.\2', $file);
								if (($f0 != $f1) && file_exists($folder . $f0))
									$this->resolve("$folder$f0", "$folder$f1");
								//	echo("-- path: $folder -- $f1 vs. $f0\n");
							}
						}


					//	resolve: procedure(file x file);
					//	resolve: resolve a duplicate

						function resolve($f0, $f1) {
							//	echo("resolve('$f1', '$f0')\n");
							if (filesize($f0) >= filesize($f1)) {
								if ($this->simulate)
									echo("remove('$f1')\n");
								else
									unlink($f1);
							} else {
								if ($this->simulate) {
									echo("remove('$f0')\n");
									echo("rename('$f1', '$f0')\n");
								} else {
									unlink($f0);
									rename($f1, $f0);
								}
							}
						}




					//	folder_event: procedure;
					//	folder_event: the hook for a folder (full path/filename is in $file)

						function folder_event() {
							//	do nuthin', just recurse ;-)
						}

				}


	//	main

		$spider = new iTunesCleanUp(/* false */);
		$spider->run();



/*	version history /-

	2007/05/20	changed for itunes smart delete duplicates crawler  [er]
	2004/03/25	created from original  [er]
	-- v0.1 --


*/


?>